// Rubr.cpp: implementation of the Rubr class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Rubrikator.h"
#include "Rubr.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Rubr::Rubr()
{
	B.numR=0;
	B.numP=0;
	B.numD=0;
	
	tmpID=-1;
	Porog=1;
	
	RR.B.rubriks=new rubriksstruct[100];
	RR.B.documents=new documentsstruct[1000];
}

Rubr::~Rubr()
{

}




/************************************************************************/
/*    /           */
/************************************************************************/

/*      file,    . */
int Rubr::LoadSettings(CString file)
{
	CFile fr;
	CString str, num, sm, y;
	char c;
	bool endfile = false;
	int i=0, j=0, k=0;
	
	y.Format("%s\\%s",CurrentDir, file);
	
	if(!fr.Open(y, CFile::modeRead, NULL)) return -1;
	else
	{
		for (k=0; k<2; k++)
		{
			str.Empty();
			do
			{
				if(fr.Read(&c, 1)<1) endfile = true;
				if(c!='\n' && c!=0x0d) str+=(c);
			}
			while (c!='\n' && endfile == false);
			
			if (k==0) B.numR=atoi(str);
			if (k==1) B.numP=atoi(str);
		}
		
		
		if (B.numR>0)
		{	
			for (i=0; i<B.numR; i++)
			{
				for (k=0; k<3; k++)
				{
					str.Empty();
					do
					{
						if(fr.Read(&c, 1)<1) endfile = true;
						if(c!='\n' && c!=0x0d) str+=(c);
					}
					while (c!='\n' && endfile == false);
					
					if (k==0)	B.rubriks[i].name=str;
					if (k==1)	B.rubriks[i].dir=str;
					if (k==2)	B.rubriks[i].numK=atoi(str);
				}
				
				for (j=0; j<B.rubriks[i].numK; j++)
				{
					str.Empty();
					do
					{
						if(fr.Read(&c, 1)<1) endfile = true;
						if(c!='\n' && c!=0x0d) str+=(c);
					}
					while (c!='\n' && endfile == false);
					
					B.rubriks[i].keyword[j]=str;
				}
			}
			
		}

		if (B.numP>0)
		{	
			for (i=0; i<B.numP; i++)
			{
				str.Empty();
				do
				{
					if(fr.Read(&c, 1)<1) endfile = true;
					if(c!='\n' && c!=0x0d) str+=(c);
				}
				while (c!='\n' && endfile == false);
				
				B.paths[i]=str;
			}
			
		}
		return 1;
	}
}

/*    file. */
int Rubr::SaveSettings(CString file)
{
	CFile fr;
	CString str, num, sm, y;
	bool endfile = false;
	int i=0, j=0;
	
	y.Format("%s\\%s",CurrentDir, file);
	
	if(!fr.Open(y, CFile::modeCreate | CFile::modeReadWrite, NULL)) return -1;
	else
	{
		y.Format("%d\n%d\n", B.numR, B.numP);
		fr.Write(y.GetBuffer(0), y.GetLength());
		
		if (B.numR>0)
		{
			for (i=0; i<B.numR; i++)
			{
				y.Format("%s\n%s\n%d\n", B.rubriks[i].name, B.rubriks[i].dir, B.rubriks[i].numK);
				fr.Write(y.GetBuffer(0), y.GetLength());
				
				sm.Empty();
				for (j=0; j<B.rubriks[i].numK; j++)
				{
					y.Format("%s\n", B.rubriks[i].keyword[j]);
					sm.operator+=(y);
				}
				fr.Write(sm.GetBuffer(0), sm.GetLength());
			}
		}
		
		if (B.numP>0)
		{
			for (i=0; i<B.numP; i++)
			{
				y.Format("%s\n", B.paths[i]);
				fr.Write(y.GetBuffer(0), y.GetLength());
			}
		}
		
		return 1;
	}
	return 0;

}



/************************************************************************/
/* ,        -              */
/************************************************************************/

/*     file
	0 - doc.
	1 - txt.
   -1 -   doc   txt.	*/
int Rubr::DocumentType(CString file)
{
	CString y,sm;
	file.MakeLower();
	for (int i=file.GetLength()-3; i<file.GetLength(); i++)
		y.operator += (file[i]);
	
	if (y=="doc")		return 0;
	else if (y=="txt")	return 1;
	
	return -1;
}

/*     TXT file 
	words -     
	numW  -          -.
   :
	-   (words, numW).   */
int Rubr::LoadFromTXT(CString file, CString *words, int *numW)
{
	CFile fr;
	CString str;
	bool endfile = false;
	int j=0;
	char c;
	
	CString  sss, sm;
	
	if(!fr.Open(file, CFile::modeRead, NULL)) return -1;
	
	str.Empty();
	do
	{
		if(fr.Read(&c, 1)<1) endfile = true;
		
		if (FindMusor(c)==0) str+=(c);
		else if (str.GetLength()>=3)
		{
			str.MakeLower();
			if (FindMusor(str,1)==0)
			{
				if (in_array(words, numW, str, j, 1)==-1)
				{
					words[j]=str;
					numW[j]=1;
					j++;
				}	
			}
			str.Empty();
			
		}
		else	str.Empty(); 
		
	}while	(endfile == false);
	
	return j;
}

/*     DOC file 
	words -     
	numW  -          -.
   :
	-   (words, numW).   */
int Rubr::LoadFromDOC(CString file, CString *words, int *numW)
{
	bool endfile=false;
	char c1,c2;
	CString c, str;
	int i=0,j=0;
	char *rus_big="";
	char *rus_small="";
	CFile fr;
	
	if(!fr.Open(file, CFile::modeRead, NULL)) return -1;
	
	do
	{
		if(fr.Read(&c1, 1)<1) endfile = true;
		if(fr.Read(&c2, 1)<1) endfile = true;
		if (c2==0)
		{
			if (c1==13) c.operator =("\n"); /*     . */
			if ((c1>=0x20) && (c1<=0x7F)) c.operator =(c1);
		}
		if (c2==4)
		{
			if ((c1>=0x10) && (c1<=0x2F)) c.operator =(rus_big[c1-0x10]);
			if ((c1>=0x30) && (c1<=0x4F)) c.operator =(rus_small[c1-0x30]);
		}
		
		if (FindMusor(c)==0) str+=(c);
		
		else if (str.GetLength()>=3 && str.GetLength()<25) 
		{
			str.MakeLower();
			if (FindMusor(str,1)==0)
			{
				if (in_array(words, numW, str, j, 1)==-1)
				{
					words[j]=str;
					numW[j]=1;
					j++;
				}
			}
			str.Empty();
		}
		else str.Empty();
	}
	while (endfile == false);
	
	return j;
}

/*      -     , 
     -  ,   .. 

    2    -   mode (  0).
    mode=0 -     "c"    .
	mode=1 -     "c"    .

   : 
	0 -  ""     "".
	1 -  "" -  "".	*/
int Rubr::FindMusor(CString c, int mode)
{
	int i;
	CString str;
	if (mode==0)
	{
		if (c=='\n' || c==' ' || c=='.' || c==',' || c==':' || c==';' || c=='?' || c=='!'
			
			|| c=='/' || c=='|' || c=='	'
			
			|| c=='"' || c=='\'' || c=='' || c=='' || c=='`'
			
			|| c=='' || c=='@' || c=='$' || c=='=' || c=='-' || c=='*' || c=='%'  || c=='~'
			
			|| c=='<' || c=='>' || c=='+' || c=='#'
			
			|| c=='{' || c=='}' || c=='[' || c==']' || c=='(' || c==')'
			
			|| c=='_' || c=='&' || c=='^'  || c==0x0d) 
			
			return 1;
	}
	else if (mode==1)
	{
		c.MakeLower();
		
		if ( c=="mergeformatinet" || c=="includepicture" || c=="mathh" || c=="new" || c=="root"
			|| c=="" || c=="" || c=="" || c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c=="" || c=="" || c==""  || c==""
			|| c=="" || c=="" || c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c=="" || c=="" || c=="not"
			|| c=="" || c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c=="" || c==""  || c==""
			|| c=="" || c=="" || c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c=="" || c=="" || c=="" || c==""  || c==""
			|| c==""  || c=="" || c==""  || c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c=="" || c=="" || c=="" 
			|| c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c==""  || c=="" || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="the" || c=="and" || c=="you" || c=="your" || c=="" || c==""
			|| c==""  || c=="" || c=="" || c==""  || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c==""  || c=="" || c=="" || c==""
			|| c=="" || c=="" || c=="" || c=="" || c=="" || c=="" || c=="" || c==""
			|| c=="" || c==""  || c=="" || c=="" || c=="" || c=="" || c=="")	return 1;


			//   doc       
			//    4    .
			if (c.GetLength()>3)
			{
				for (i=0; i<c.GetLength()-3; i++)
				{
					if (c[i]==c[i+1] && c[i]==c[i+2] && c[i]==c[i+3])	return 1;	
				}
			}
		
	}
	
	return 0;
}

/*    b .
	return:
	1 - 
	0 -   */
int Rubr::Glasnaya(CString b)
{
	if (b=='' || b=='' || b=='' || b=='' || b=='' || b=='' || b=='' || b==''
		 || b=='' || b=='' || b=='')	return 1;
	
	return 0;
}





/************************************************************************/
/*         .      */
/************************************************************************/


/*          .

	LPCTSTR lpszFileName,	//      
	BOOL bInnerFolders		// TRUE -   . 
							// FALSE -     

	  B.documents[].path    .	*/
bool Rubr::SearchFiles(LPCTSTR lpszFileName, BOOL bInnerFolders)
{
	// http://www.cyberguru.ru/cpp-sources/files-folders/poisk-fajlov.html
	
    LPTSTR part;
    char tmp[MAX_PATH]; //  
    char name[MAX_PATH];
	
	HANDLE hSearch = NULL;
	WIN32_FIND_DATA wfd;
	
    memset(&wfd, 0, sizeof(WIN32_FIND_DATA));
	
    //       ...
    if(bInnerFolders)
    {
        if(GetFullPathName(lpszFileName, MAX_PATH, tmp, &part) == 0) return FALSE;
        strcpy(name, part);
        strcpy(part, "*.*");
		
        //   ,   
        wfd.dwFileAttributes = FILE_ATTRIBUTE_DIRECTORY;
        if (!((hSearch = FindFirstFile(tmp, &wfd)) == INVALID_HANDLE_VALUE))
			do
			{
				//         "."  ".."
				//      
				
				//   "."  ".."
				if (!strncmp(wfd.cFileName, ".", 1) || !strncmp(wfd.cFileName, "..", 2))
					continue;
				
				if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) //    
				{
					char next[MAX_PATH];
					if(GetFullPathName(lpszFileName, MAX_PATH, next, &part) == 0) return FALSE;
					strcpy(part, wfd.cFileName);
					strcat(next, "\\");
					strcat(next, name);
					
					SearchFiles(next, TRUE);
				}
			}
			while (FindNextFile(hSearch, &wfd)); //   
			
			FindClose (hSearch); //  
    }
	
	if ((hSearch = FindFirstFile(lpszFileName, &wfd)) == INVALID_HANDLE_VALUE) 
		return TRUE; //    
	do
	if (!(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) //    
	{
        char file[MAX_PATH];
        if(GetFullPathName(lpszFileName, MAX_PATH, file, &part) == 0) return FALSE;
        strcpy(part, wfd.cFileName);
		
		CString y;
		y.Format("%s",file);
		
		if (RR.DocumentType(file)==0 || RR.DocumentType(file)==1)
		{
			B.documents[B.numD].path=y;
			B.numD++;
		}
		
	}
	while (FindNextFile(hSearch, &wfd)); //   
	FindClose (hSearch); //  
	
    return TRUE;
}

/*	    str,   words.
	words -  , numW -      words. 
	countW - -  (words,  numW)
	mode -    (  0):
	 mode=0 -    str,   words,   .
	 mode=1 -   str  ,   -     1 (..   numW)+
			  +    -   ..   numW. 
	 mode=2 -    mode=0  +    - (""   ).

	:
	 -1 - str     words.
	 >0 - id   words,    str.	*/
int Rubr::in_array(CString *words, int *numW, CString str, int countW, int mode, int *sumVW)
{
	int rez=-1, ex=0, max=0, id=0, j, k, t;
	CString y, str2;
	
	if (mode==0)
	{
		for (j=0; j<countW; j++)
			if (words[j]==str)	rez=j;
	}
	else if (mode==1)
	{
		for (j=0; j<countW; j++)
		{
			if (words[j]==str)
			{
				numW[j]++;
				max=numW[j]; y=words[j];
				rez=j;
			}
			
			if (rez!=-1 && j<countW-1)
			{
				words[j]=words[j+1];
				numW[j]=numW[j+1];
			}
		}
		
		
		for (j=0; j<countW-1; j++)
		{
			if (numW[j]<max)
			{
				for (k=countW-1; k>j; k--)
				{
					words[k]=words[k-1];
					numW[k]=numW[k-1];
				}
				words[j]=y;numW[j]=max;
				j=countW;
			}
		}
	}
	else if (mode==2)
	{

		CString sm;

		for (j=0; j<countW; j++)
		{
			// -.
			for (t=0; t<=3; t++)
			{
				str2.Empty();
				for (k=0; k<words[j].GetLength()-t; k++)
					str2.operator += (words[j][k]);
				
				if (str.GetLength() >= 3)
				{
					y.Format("%s=%s\n", str2,str);
					sm.operator += (y);
					
					if (str2==str)
					{							
						*sumVW+=numW[j];
						numW[j]=0;
						rez=j;
						break;
					}
				}
			}

			//if (rez>-1) break;
		}
		//y.Format("[sumVW=%d],",*sumVW);
		//AfxMessageBox(y);
		
		//AfxMessageBox(sm);
		
	}
	
	return rez;
}

/*	   ,   
	idDoc - id    B.documents[]

	:
	 >0 - id    .
	 -1 -    .	*/
int Rubr::DefineRubr(int idDoc)
{	
	CString words[100000], str;
	int numW[50000], numW2[50000], Ksum[500], countW=0, i, j, n, k, br=0;
	double sVP=0, VP[500];
	
	//  ,        
	//       .
	int type=DocumentType(B.documents[idDoc].path);
	
	if (type==0)
		countW=LoadFromDOC(B.documents[idDoc].path, words, numW);
	else if (type==1) 
		countW=LoadFromTXT(B.documents[idDoc].path, words, numW);
	
	if (countW>0)
	{
		int sum=0, sum2=0, sr=0, s=1;
		int sum3=0, sumVW=0;
		
		CString y;
		
		for (j=0; j<countW; j++)
		{
			numW2[j]=numW[j];
			sum+=numW[j];
		}

		for (i=0; i<RR.B.numR; i++)
		{
			sVP=0;
			sum2=0;		

			for (j=0; j<RR.B.rubriks[i].numK; j++)
			{
				// -.
				n=-1;
				sumVW=0;
				br=0;
				if (RR.B.rubriks[i].keyword[j].GetLength()>3)
				{
					str.Empty();

					for (int t=0; t<=5; t++)
					{
						str.Empty();
						for (k=0; k<RR.B.rubriks[i].keyword[j].GetLength()-t; k++)
						{
							if (t>0)
							{
								//   - .
								if (Glasnaya(RR.B.rubriks[i].keyword[j][RR.B.rubriks[i].keyword[j].GetLength()-t])==1)
								{
									str.operator += (RR.B.rubriks[i].keyword[j][k]);
								}
								else
								{
									br=1;
									break;
								}
							}
							else	str.operator += (RR.B.rubriks[i].keyword[j][k]);
						}

						if (br==1) break;

						//AfxMessageBox(str);

						if (str.GetLength() >= 3)
						{
							//AfxMessageBox(str);
							n=in_array(words, numW, str, countW, 2, &sumVW);
							
							y.Format("sumVW=%d,", sumVW);
							//AfxMessageBox(y);
							
							//if (n>=0)	break;
						}
					}
				}
				else n=in_array(words, numW, RR.B.rubriks[i].keyword[j], countW, 2, &sumVW);

				if (n>=0)
				{
					sum2+=sumVW;
				}
			}
			for (j=0; j<countW; j++)	numW[j]=numW2[j];
			
			sVP=(double)((double)sum2*(double)100/(double)sum);
			
			y.Format("sVP=%lf%%, sum2=%d sum=%d [%s]",sVP, sum2, sum, B.rubriks[i].name);
			//AfxMessageBox(y);
			
			
			VP[i]=sVP;
			Ksum[i]=sum2;
		}
		
		int win=DefWin(VP);
		
		//VP[win] -      .
		
		//y.Format("VP[%d]=%lf%%, slov=%d, [%s]",win, VP[win], Ksum[win], B.rubriks[win].name);
		//AfxMessageBox(y);
		
		
		
		
		
		if (VP[win]>Porog /*&& Ksum[win]>2*/) //     > %
		{
			B.documents[idDoc].idR=win;
			B.documents[idDoc].procent=VP[win];
			return win;
		}
		else
		{
			B.documents[idDoc].idR=-1;
			B.documents[idDoc].procent=0;
			return -1;
		}
		
		
		
	}
	return -1;
}








/*   id   vector   . */
int Rubr::DefWin(double *vector)
{
	int index, sel;
	double max;
	
	sel = 0;
	max = vector[sel];
	
	for (index = 1 ; index < B.numR ; index++)
	{
		if (vector[index] > max)
		{
			max = vector[index]; sel = index;
		}
	}
	return( sel );
}

/*            ,  -1. */
int Rubr::SearchProbel(CString str)
{
	int i;
	for (i=0; i<str.GetLength(); i++)
	{
		if (str[i]==' ') return i;
	}
	return -1;
}

/*    -     . */
int Rubr::CountAllKeyword()
{
	int sum=0, i;
	for (i=0; i<B.numR; i++)
	{
		sum+=B.rubriks[i].numK;
	}
	return sum;
}


int Rubr::moveFile(int docID)
{
	int j;
	CString y, str, str2;
	char c;
	CFile fr, fw;
	bool endfile = false;
	
	//     :)
	str.Empty();
	for (j=0; j<RR.B.documents[docID].path.GetLength(); j++)
	{
		if (RR.B.documents[docID].path[j]!='\\')
			str.operator += (RR.B.documents[docID].path[j]);
		else	str.Empty();
	}

	if (RR.B.documents[docID].idR>=0)
	{
		y.Format("%s\\%s", RR.B.rubriks[RR.B.documents[docID].idR].dir, str);

		//  MoveFile(RR.B.documents[docID].path, y); 
		//     ...
		
		/*      ) */
		if(!fr.Open(RR.B.documents[docID].path, CFile::modeRead, NULL))	return -2;
		else
		{
			if(!fw.Open(y, CFile::modeCreate | CFile::modeReadWrite, NULL))	return -3;
			else
			{		
				str.Empty();
				endfile=false;
				do
				{
					if(fr.Read(&c, 1)<1) endfile = true;
					str.operator += (c);
				}
				while (endfile == false);
				fw.Write(str.GetBuffer(0), str.GetLength());
			}
		}

		fr.Close();
		fw.Close();
		
		try
		{
			CFile::Remove(RR.B.documents[docID].path);
			return 1;
		}
		catch (CFileException* pEx)
		{
			pEx->Delete();
			return 0;
		}
	}
	else return -1;
}

//  ,   .
CString Rubr::NewPath()
{
	char szWorkDir[MAX_PATH];
	char sz[MAX_PATH];
	CString y;
	
	HWND hwnd=HWND();
	
	BROWSEINFO bi= {hwnd,  // 
		NULL,
		(LPSTR)szWorkDir,  // 
		"Please, choose the folder...",  //                       
		BIF_DONTGOBELOWDOMAIN | BIF_RETURNONLYFSDIRS | BIF_EDITBOX | BIF_BROWSEFORCOMPUTER,  // 
		0,  // -  
		NULL, //    
		0}; //    
	
	LPCITEMIDLIST lpItemDList;
	
	if(!(lpItemDList=SHBrowseForFolder(&bi)))
	{
		// -  !
	}
	//    
	SHGetPathFromIDList(lpItemDList, sz); // sz - ,   ...

	y.Format("%s", sz);

	return y;
}

//   ...
// retrun: 1 - ; -1 - .
int Rubr::delDocument(int docID)
{
	int ex=-1;
	if (docID>=0 && docID<B.numD)
	{
		for(int i=0; i<B.numD-1; i++)
		{
			if (docID==i)	ex=1;
			
			if (ex==1)	B.documents[i]=B.documents[i+1];
		}
		B.numD--;
		return 1;
	}
	return -1;
}

int Rubr::AddNewPath(CString y)
{
	RR.B.paths[RR.B.numP]=y;
	RR.B.numP++;
	
	SaveSettings("settings.dat");
	return 1;
}
